/// <reference types="node" />
import { FrameLocator, Locator, Page } from "playwright";
export default class Action {
    readonly page: Page;
    static iframe: FrameLocator;
    constructor(page: Page);
    clickSubmitButton(buttonText: string): Promise<void>;
    static selectDropDownOption(option: string): Locator;
    static getRandomDropDownOption(): Promise<void>;
    static getDropDownOption(option: string): Locator;
    static selectApplication(productName: string): Promise<void>;
    static clickSubmitButton(buttonText: string): Promise<void>;
    static getRandomName(arr: string[]): string;
    static isElementDisplayed(element: Locator): Promise<boolean>;
    static generateNumericString(length: number): string;
    static generateAlphaNumericString(length: number): string;
    static getCUrrentUrl(): Promise<string>;
    static ReadFileContent(filePath: string): Promise<string>;
    static WriteToJsonFile(filePath: string, jsonContent: object): Promise<void>;
    static writeOrAppendJSONFile(filename: any, key: string | number, value: any): Promise<void>;
    static uploadDocument(fileName1: string, fileName2?: string, fileName3?: string): Promise<void>;
    static WriteToFileNow(file: any, data: string | NodeJS.ArrayBufferView): Promise<void>;
    static getFirstWordBeforeSpace(text: string): Promise<string | null>;
}
