"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var world_1 = require("../configs/world");
var fs = require("fs");
var path = require("path");
var promises_1 = require("fs/promises");
var Action = /** @class */ (function () {
    function Action(page) {
        this.page = page;
        Action.iframe = page.frameLocator("#iframe");
    }
    Action.prototype.clickSubmitButton = function (buttonText) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, ((_a = Action.iframe.locator('//span[contains(text(),"' + buttonText + '")]')) === null || _a === void 0 ? void 0 : _a.click())];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Action.selectDropDownOption = function (option) {
        // const dropDownItem = await this.iframe.locator("//button[@role='option' and .//*[contains(text(),'" + option + "')]]").textContent();
        // await locator.selectOption(dropDownItem)
        // await dropDownItem.scrollIntoViewIfNeeded();
        return this.iframe.locator("//button[@role='option' and .//*[contains(text(),'" + option + "')]]");
    };
    Action.getRandomDropDownOption = function () {
        return __awaiter(this, void 0, void 0, function () {
            var dropDownOptions, randomIndex, _i, dropDownOptions_1, iterator;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.iframe.locator("//button[@role='option']").all()];
                    case 1:
                        dropDownOptions = _a.sent();
                        randomIndex = Math.floor(Math.random() * dropDownOptions.length);
                        _i = 0, dropDownOptions_1 = dropDownOptions;
                        _a.label = 2;
                    case 2:
                        if (!(_i < dropDownOptions_1.length)) return [3 /*break*/, 5];
                        iterator = dropDownOptions_1[_i];
                        if (!(iterator.getAttribute("disabled") == null)) return [3 /*break*/, 4];
                        return [4 /*yield*/, iterator.click()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        _i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    Action.getDropDownOption = function (option) {
        return this.iframe.locator("//button[@role='option' and .//*[contains(text(),'" + option + "')]]");
    };
    Action.selectApplication = function (productName) {
        return __awaiter(this, void 0, void 0, function () {
            var productCard;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        productCard = Action.iframe.locator("//h5[contains(text(),'" + productName + "')]");
                        return [4 /*yield*/, productCard.nth(0).isEnabled()];
                    case 1:
                        if (!_a.sent()) return [3 /*break*/, 3];
                        return [4 /*yield*/, productCard.nth(0).click()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Action.clickSubmitButton = function (buttonText) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, ((_a = Action.iframe.locator('//span[contains(text(),"' + buttonText + '")]')) === null || _a === void 0 ? void 0 : _a.click())];
                    case 1:
                        _b.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Action.getRandomName = function (arr) {
        var randomIndex = Math.floor(Math.random() * arr.length);
        var item = arr[randomIndex];
        return item;
    };
    Action.isElementDisplayed = function (element) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, element.isVisible({ timeout: 30000 })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Action.generateNumericString = function (length) {
        var alPhanumericString = "";
        var characters = "0123456789";
        var charactersLength = characters.length;
        for (var i = 0; i < length; i++) {
            alPhanumericString += characters.charAt(Math.floor(Math.random() * charactersLength));
        }
        return alPhanumericString;
    };
    Action.generateAlphaNumericString = function (length) {
        var alPhanumericString = "";
        var characters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        var charactersLength = characters.length;
        for (var i = 0; i < length; i++) {
            alPhanumericString += characters.charAt(Math.floor(Math.random() * charactersLength));
        }
        return alPhanumericString;
    };
    Action.getCUrrentUrl = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, world_1.page.waitForLoadState()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, world_1.page.url()];
                }
            });
        });
    };
    Action.ReadFileContent = function (filePath) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, promises_1.readFile)(path.join(__dirname, "../../".concat(filePath)), "utf8")];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Action.WriteToJsonFile = function (filePath, jsonContent) {
        return __awaiter(this, void 0, void 0, function () {
            var fileStore;
            return __generator(this, function (_a) {
                fileStore = path.join(__dirname, "../".concat(filePath));
                fs.writeFile(fileStore, JSON.stringify(jsonContent, null, 2), function (err) {
                    if (err) {
                        console.log("An error occured while attempting to read the file", err);
                        return;
                    }
                });
                return [2 /*return*/];
            });
        });
    };
    Action.writeOrAppendJSONFile = function (filename, key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var fileStore, data, jsonData, jsonData;
            var _a;
            return __generator(this, function (_b) {
                fileStore = path.join(__dirname, "../".concat(filename));
                if (fs.existsSync(fileStore)) {
                    data = fs.readFileSync(fileStore, 'utf8');
                    jsonData = JSON.parse(data);
                    if (jsonData.hasOwnProperty(key)) {
                        jsonData[key].push(value);
                    }
                    else {
                        jsonData[key] = [value];
                    }
                    fs.writeFileSync(fileStore, JSON.stringify(jsonData, null, 2));
                }
                else {
                    jsonData = (_a = {},
                        _a[key] = [value],
                        _a);
                    fs.writeFileSync(fileStore, JSON.stringify(jsonData, null, 2));
                }
                return [2 /*return*/];
            });
        });
    };
    Action.uploadDocument = function (fileName1, fileName2, fileName3) {
        return __awaiter(this, void 0, void 0, function () {
            var error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        //   await page.evaluate(() => {
                        //     let inputElement = document.querySelectorAll('[type="file"]');
                        //     inputElement.forEach((ele) => {
                        //       ele.removeAttribute("style");
                        //     });
                        //   });
                        return [4 /*yield*/, world_1.page.setInputFiles("//input[@type='file']", "screenshots/screenshot.png")];
                    case 1:
                        //   await page.evaluate(() => {
                        //     let inputElement = document.querySelectorAll('[type="file"]');
                        //     inputElement.forEach((ele) => {
                        //       ele.removeAttribute("style");
                        //     });
                        //   });
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        throw new Error("An error occured while attempting to upload the file : ".concat(error_1));
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    Action.WriteToFileNow = function (file, data) {
        return __awaiter(this, void 0, void 0, function () {
            var fileStore;
            return __generator(this, function (_a) {
                fileStore = path.join(__dirname, "../".concat(file));
                fs.writeFileSync(fileStore, data);
                return [2 /*return*/];
            });
        });
    };
    Action.getFirstWordBeforeSpace = function (text) {
        return __awaiter(this, void 0, void 0, function () {
            var trimmedText, indexOfSpace;
            return __generator(this, function (_a) {
                trimmedText = text.trim();
                indexOfSpace = trimmedText.indexOf(' ');
                if (indexOfSpace === -1) {
                    return [2 /*return*/, trimmedText];
                }
                else {
                    return [2 /*return*/, trimmedText.substr(0, indexOfSpace)];
                }
                return [2 /*return*/];
            });
        });
    };
    return Action;
}());
exports.default = Action;
